> For the complete documentation index, see [llms.txt](https://developer.vario-software.de/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.vario-software.de/api-reference/product-variant.md).

# Product Variant

Manage product variants via the VARIO Cloud REST API, including creating variants, updating fields, and retrieving schemas and combinations.

the Product-Variant API

## POST /erp/product-variants/productVariantUpdateJob

> Start a job that transfers the main variant article's selected areas to all variants

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Product-Variant","description":"the Product-Variant API"}],"servers":[{"url":"api.example.com"}],"paths":{"/erp/product-variants/productVariantUpdateJob":{"post":{"tags":["Product-Variant"],"summary":"Start a job that transfers the main variant article's selected areas to all variants","operationId":"createProductVariantUpdateRequest","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/erp-product-ProductVariantUpdateRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/core-api-OperationMessage"}}}}}}}},"components":{"schemas":{"erp-product-ProductVariantUpdateRequest":{"properties":{"mainArticleId":{"type":"integer","format":"int64","description":"Main article identifier."},"fields":{"type":"array","description":"Areas to transfer.","items":{"type":"string","description":"Areas that can be transferred from the main variant article to the variant articles.","enum":["PRICES","MANUFACTURER","PRODUCT_GROUP","SUPPLIER_RELATIONS","ARTICLE_DESCRIPTIONS","CUSTOM_FIELDS"]}}},"required":["mainArticleId"]},"core-api-OperationMessage":{"properties":{"context":{"type":"string","description":"message context"},"messageValue":{"type":"string","description":" message"}}}}}}
```

## POST /erp/product-variants/productVariantCreationJob

> Create a Job according to the Request

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Product-Variant","description":"the Product-Variant API"}],"servers":[{"url":"api.example.com"}],"paths":{"/erp/product-variants/productVariantCreationJob":{"post":{"tags":["Product-Variant"],"summary":"Create a Job according to the Request","operationId":"createProductVariantCreationRequest","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/erp-product-ProductVariantCreationRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/core-api-OperationMessage"}}}}}}}},"components":{"schemas":{"erp-product-ProductVariantCreationRequest":{"description":"Request for creating product variants.","properties":{"mainArticleRef":{"$ref":"#/components/schemas/core-api-ApiObjectReference"},"combinations":{"type":"array","description":"combinations of values","items":{"type":"array","description":"combinations of values","items":{"type":"integer","format":"int64","description":"combinations of values"}}},"blackListedCombinations":{"type":"array","description":"blacklisted combinations of values","items":{"type":"array","description":"blacklisted combinations of values","items":{"type":"integer","format":"int64","description":"blacklisted combinations of values"}}},"productType":{"type":"string","description":"Article types.","enum":["WITH_STOCK","WITHOUT_STOCK","SERVICE_ARTICLE","SERVICE_CONTINGENT","ASSEMBLY_GROUP","JUMBO","SHIPPING_COSTS","VARIANT_MAIN_ARTICLE"]},"createTemplateId":{"type":"integer","format":"int64","description":"Template for creating the variant articles."}},"required":["productType"]},"core-api-ApiObjectReference":{"description":"Parent category.","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Active.","readOnly":true}},"required":["id"]},"core-api-OperationMessage":{"properties":{"context":{"type":"string","description":"message context"},"messageValue":{"type":"string","description":" message"}}}}}}
```

## GET /erp/product-variants/{mainVariantArticleId}/combinations

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Product-Variant","description":"the Product-Variant API"}],"servers":[{"url":"api.example.com"}],"paths":{"/erp/product-variants/{mainVariantArticleId}/combinations":{"get":{"tags":["Product-Variant"],"operationId":"getCombinationsForArticleMainProductVariant","parameters":[{"name":"mainVariantArticleId","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/erp-product-ProductVariantCombinationsDto"}}}}}}}},"components":{"schemas":{"erp-product-ProductVariantCombinationsDto":{"properties":{"variantSchema":{"$ref":"#/components/schemas/common-variant-VariantSchema"},"attributes":{"type":"array","description":"Attributes used.","items":{"$ref":"#/components/schemas/common-variant-VariantAttribute"}},"values":{"type":"array","description":"Values used.","items":{"$ref":"#/components/schemas/common-variant-VariantValue"}},"usedCombinations":{"type":"array","description":"Combinations used.","items":{"$ref":"#/components/schemas/erp-product-ProductCombinationDto"}}}},"common-variant-VariantSchema":{"description":"Variant schema.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"label":{"type":"string","description":"Label.","minLength":1},"description":{"type":"string","description":"Description."},"attributeRefs":{"type":"array","description":"Assigned attributes.","items":{"$ref":"#/components/schemas/core-api-ApiObjectReference"},"minItems":1},"eligibleValueRefs":{"type":"array","description":"Eligible values.","items":{"$ref":"#/components/schemas/core-api-ApiObjectReference"}},"active":{"type":"boolean","default":true,"description":"Is this active?","readOnly":true}},"required":["attributeRefs","label"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"core-api-ApiObjectReference":{"description":"Parent category.","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Active.","readOnly":true}},"required":["id"]},"common-variant-VariantAttribute":{"description":"Variant attribute.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"identifier":{"type":"string","description":"Unique identifier.","maxLength":255,"minLength":0},"description":{"type":"string","description":"Description."},"active":{"type":"boolean","default":true,"description":"Is this active?","readOnly":true},"labels":{"type":"array","description":"Label (multilingual).","items":{"$ref":"#/components/schemas/common-variant-VariantDescription"},"minItems":1}},"required":["identifier","labels"]},"common-variant-VariantDescription":{"description":"Variant description (multilingual).","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"label":{"type":"string","description":"Label.","minLength":1},"languageCode":{"type":"string","description":"Language.","minLength":1}},"required":["label","languageCode"]},"common-variant-VariantValue":{"description":"Variant value.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"attributeRef":{"$ref":"#/components/schemas/core-api-ApiObjectReference"},"sortOrder":{"type":"integer","format":"int64","description":"Sort order."},"active":{"type":"boolean","default":true,"description":"Is this active?","readOnly":true},"abbreviation":{"type":"string","description":"Abbreviation.","minLength":1},"unitTypeRef":{"$ref":"#/components/schemas/common-masterdata-UnitTypeReference"},"labels":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/common-variant-VariantDescription"},"minItems":1}},"required":["abbreviation","labels"]},"common-masterdata-UnitTypeReference":{"description":"net weight unit","properties":{"id":{"type":"integer","format":"int64","description":"unit type id"},"name":{"type":"string","description":"descriptive name","maxLength":255,"minLength":0},"abbreviation":{"type":"string","description":"unique abbreviation","maxLength":255,"minLength":0}},"required":["abbreviation"]},"erp-product-ProductCombinationDto":{"description":"Combinations used.","properties":{"article":{"$ref":"#/components/schemas/core-api-ApiObjectReference"},"combination":{"type":"array","description":"Value combination.","items":{"$ref":"#/components/schemas/core-api-ApiObjectReference"},"readOnly":true}}}}}}
```

## GET /erp/product-variants/schema/{variantSchemaId}

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Product-Variant","description":"the Product-Variant API"}],"servers":[{"url":"api.example.com"}],"paths":{"/erp/product-variants/schema/{variantSchemaId}":{"get":{"tags":["Product-Variant"],"operationId":"getProductVariantSchema","parameters":[{"name":"variantSchemaId","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/erp-product-ProductVariantSchema"}}}}}}}},"components":{"schemas":{"erp-product-ProductVariantSchema":{"description":"Variant schema with the ERP configuration.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"label":{"type":"string","description":"Label.","readOnly":true},"description":{"type":"string","description":"Description.","readOnly":true},"active":{"type":"boolean","default":true,"description":"Is this active?","readOnly":true},"attributes":{"type":"array","description":"Assigned attributes with the container information.","items":{"$ref":"#/components/schemas/erp-product-ProductVariantAttribute"},"readOnly":true},"eligibleValueRefs":{"type":"array","description":"Eligible values.","items":{"$ref":"#/components/schemas/core-api-ApiObjectReference"},"readOnly":true}}},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"erp-product-ProductVariantAttribute":{"description":"Variant attribute with the ERP configuration.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"description":{"type":"string","description":"Description.","readOnly":true},"active":{"type":"boolean","default":true,"description":"Is this active?","readOnly":true},"labels":{"type":"array","description":"Label (multilingual).","items":{"$ref":"#/components/schemas/common-variant-VariantDescription"},"readOnly":true},"bundleAttribute":{"type":"boolean","default":false,"description":"Is this attribute a bundle attribute?","readOnly":true},"attributeAssignmentConfigId":{"type":"integer","format":"int64","description":"Associated ERP configuration identifier.","readOnly":true}}},"common-variant-VariantDescription":{"description":"Variant description (multilingual).","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"label":{"type":"string","description":"Label.","minLength":1},"languageCode":{"type":"string","description":"Language.","minLength":1}},"required":["label","languageCode"]},"core-api-ApiObjectReference":{"description":"Parent category.","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Active.","readOnly":true}},"required":["id"]}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developer.vario-software.de/api-reference/product-variant.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
